# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = [
    'GetXoaResourceSetResult',
    'AwaitableGetXoaResourceSetResult',
    'get_xoa_resource_set',
    'get_xoa_resource_set_output',
]

@pulumi.output_type
class GetXoaResourceSetResult:
    """
    A collection of values returned by getXoaResourceSet.
    """
    def __init__(__self__, id=None, name=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The name of the resource set to look up.
        """
        return pulumi.get(self, "name")


class AwaitableGetXoaResourceSetResult(GetXoaResourceSetResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetXoaResourceSetResult(
            id=self.id,
            name=self.name)


def get_xoa_resource_set(name: Optional[str] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetXoaResourceSetResult:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_xenorchestra as xenorchestra

    rs = xenorchestra.get_xoa_resource_set(name="my resource set")
    ```


    :param str name: The name of the resource set to look up.
    """
    __args__ = dict()
    __args__['name'] = name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('xenorchestra:index/getXoaResourceSet:getXoaResourceSet', __args__, opts=opts, typ=GetXoaResourceSetResult).value

    return AwaitableGetXoaResourceSetResult(
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'))
def get_xoa_resource_set_output(name: Optional[pulumi.Input[str]] = None,
                                opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetXoaResourceSetResult]:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_xenorchestra as xenorchestra

    rs = xenorchestra.get_xoa_resource_set(name="my resource set")
    ```


    :param str name: The name of the resource set to look up.
    """
    __args__ = dict()
    __args__['name'] = name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('xenorchestra:index/getXoaResourceSet:getXoaResourceSet', __args__, opts=opts, typ=GetXoaResourceSetResult)
    return __ret__.apply(lambda __response__: GetXoaResourceSetResult(
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name')))
